
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>SQL  Case / 憋错料</title>

    <meta name="description" content="SQL  Case 在数据库中,对数据进行比对,有两种用法, 第一种:不对任何列进行条件判断 SELECT Student_ID AS 学号,English AS 英语成绩, CASE WHEN English&gt;=120 THEN '优秀' WHEN English&gt;=60 AND English&lt;=100 THEN '及格' WHEN English&lt;60 THEN '不及格' END AS 描述 FROM dbo.Score 执行的结果是: 学号 英语成绩 描述 1 120 优秀 2 1 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">SQL  Case</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>在数据库中，对数据进行比对，有两种用法，</p>
<p><strong>第一种：不对任何列进行条件判断</strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre>SELECT
Student_ID  AS 学号,English AS 英语成绩,
CASE
WHEN English&gt;=120 THEN ‘优秀‘
WHEN English&gt;=60 AND English&lt;=100 THEN ‘及格‘
WHEN English&lt;60 THEN ‘不及格‘
END AS 描述
FROM dbo.Score</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>执行的结果是：</p>
<table>
<tbody>
<tr>
<td>学号</td>
<td>英语成绩　　</td>
<td>描述</td>
</tr>
<tr>
<td>1</td>
<td>120</td>
<td>优秀</td>
</tr>
<tr>
<td>2</td>
<td>100</td>
<td>及格</td>
</tr>
<tr>
<td>3</td>
<td>55</td>
<td>不及格</td>
</tr>
<tr>
<td>4</td>
<td>59</td>
<td>不及格</td>
</tr>
<tr>
<td>5</td>
<td>60</td>
<td>及格</td>
</tr>
</tbody>
</table>
<p>从Case开始判断，判断什么？不知道，当when开始的时候，才知道判断什么东西，类似于C#中的if...esle if...else..</p>
<p><strong>第二种：直接case列，值判断　</strong>　</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre>SELECT
CASE StudentID
WHEN 1 THEN ‘学号为1‘
WHEN 2 THEN ‘学号为2‘
WHEN 3 THEN ‘学号为3‘
WHEN 4 THEN ‘学号为4‘
END
FROM dbo.Student</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>执行的结果为：</p>
<p>(无列名)<br />学号为1<br />学号为2<br />学号为3<br />学号为4<br />NULL</p>
<p>看到最后一个是NULL，都不满足Case条件的话，如果没有Else语句，默认返回NULL值。</p>
<p>从Case开始，一开始就知道要判断StudentID的值，如果是1，就输出&ldquo;学号为1&rdquo;，后面依次类推。。。</p>
<p>相当于C#中的Switch（条件）case</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre>SELECT
CASE StudentID
WHEN 1 THEN ‘学号为1‘
WHEN 2 THEN ‘学号为2‘
WHEN 3 THEN ‘学号为3‘
WHEN 4 THEN ‘学号为4‘
ELSE ‘无名氏‘
END
FROM dbo.Student</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>这个SQL，执行的结果是：</p>
<p>(无列名)<br />学号为1<br />学号为2<br />学号为3<br />学号为4<br />无名氏</p>
<p><strong>&nbsp;case 多个列的情况：</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzc0NTIyMS8yMDE2MDEvNzQ1MjIxLTIwMTYwMTE2MjIzMjUwMDM4LTMyNjg2NTMxOC5qcGc=.jpg" /></strong></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 14:30:30 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>SQL  Case的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLjOzO3.html" rel="bookmark">SQL  Case  语句的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				-----简单case 使用 select 学号,姓名, case 专业 when '金融系' then '1' when '材料成型及控制工程' then '2' else '3' end from stu SQL Case 语句的使用,布布扣,bubuko.com			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qRp1z4.html" rel="bookmark">sql  case when 用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				sql语言中有没有类似C语言中的switch case的语句?? 没有,用case   when   来代替就行了.            例如,下面的语句显示中文年月         select   getdate()   as   日期,case   month(getdate())     when   11   then   '十一'     when   12   then   '十二'     else   substring('一二三四五六七八九十',   month(getda			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/7MVynz4.html" rel="bookmark">SQL CASE 多条件用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Case具有两种格式.简单Case函数和Case搜索函数. --简单Case函数 CASE sex          WHEN '1' THEN '男'          WHEN '2' THEN '女' ELSE '其他' END --Case搜索函数 CASE WHEN sex = '1' THEN '男'          WHEN sex = '2' THEN '女' ELSE '其他' END 这两种方式,可以实现相同的功能.简单Case函数的写法相对比较简洁,但是和Case搜索函数			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Yg8wO4.html" rel="bookmark">sql case when</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Case具有两种格式.简单Case函数和Case搜索函数. --简单Case函数 CASE sex WHEN '1' THEN '男' WHEN '2' THEN '女' ELSE '其他' END --Case搜索函数 CASE WHEN sex = '1' THEN '男' WHEN sex = '2' THEN '女' ELSE '其他' END 这两种方式,可以实现相同的功能.简单Case函数的写法相对比较简洁,但是和Case搜索函数相比,功能方面会有些限制,比如写判断式. 还有一个需要			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41gp1O0.html" rel="bookmark">SQL Case when 的使用方法（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				case when--then--else--end的最屌的地方应该是它既在普通的字段中使用,也可以在聚合函数中使用. 原文:http://blog.itpub.net/26451903/viewspace-733526 Case具有两种格式.简单Case函数和Case搜索函数. --Case搜索函数(推荐) CASE WHEN sex = '1' THEN '男' WHEN sex = '2' THEN '女' ELSE '其他' END --简单Case函数(不推荐) CASE sex WH			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmOe5X3.html" rel="bookmark">sql  case when then else end as用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Case具有两种格式.简单Case函数和Case搜索函数. --简单Case函数 CASE sex WHEN '1' THEN '男' WHEN '2' THEN '女' ELSE '其他' END --Case搜索函数 CASE WHEN sex = '1' THEN '男' WHEN sex = '2' THEN '女' ELSE '其他' END 这两种方式,可以实现相同的功能.简单Case函数的写法相对比较简洁,但是和Case搜索函数相比,功能方面会有些限制,比如写判断式. 还有一个需要			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/478kEYM.html" rel="bookmark">SQL case when else</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				先占个坑,sql 版本的swith case SELECT Oldvote, (CASE WHEN Oldvote=1 THEN (SELECT NOW() from dual) WHEN Oldvote=2 THEN 1 WHEN Oldvote=0 THEN 3 ELSE 3 END) as &quot;number&quot; FROM dual ;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLZDed3.html" rel="bookmark">SQL CASE 的用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				--简单case函数 case sex when '1' then '男' when '2' then '女' else '其他' end --case搜索函数 case when sex = '1' then '男' when sex = '2' then '女' else '其他' end 这两种方式,可以实现相同的功能.简单case函数的写法相对比较简洁,但是和case搜索函数相比,功能方面会有些限制,比如写判定式. 还有一个需要注重的问题,case函数只返回第一个符合条件的值,剩下的ca			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Jdl5l0.html" rel="bookmark">SQL Case when 的使用方法 （转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Case具有两种格式.简单Case函数和Case搜索函数. --简单Case函数 CASE sex WHEN '1' THEN '男' WHEN '2' THEN '女' ELSE '其他' END --Case搜索函数 CASE WHEN sex = '1' THEN '男' WHEN sex = '2' THEN '女' ELSE '其他' END 这两种方式,可以实现相同的功能.简单Case函数的写法相对比较简洁,但是和Case搜索函数相比,功能方面会有些限制,比如写判断式. 还有一个需要			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/949wv0D.html" rel="bookmark" class="title">Vue&period;js项目模板搭建</a>
					<div>
						前言 从今年(2017年)年初起,我们团队开始引入「Vue.js」开发移动端的产品.作为团队的领头人,我的首要任务就是设计 整体的架构 .一个良好的架构必定是具备丰富的开发经验后才能搭建出来的.虽然我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47pybkM.html" rel="bookmark" class="title">C语言   优先级</a>
					<div>
						过年越来越无聊了,贴完对联后无所事事的看了一下以前的C语言.关于优先级的问题有一些想要写下来的东西. 当我学习优先级的时候,记得我们的老师帅哥说:以后你们面试,如果有面试官问你们一些关于优先级的计算. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPNx7m3.html" rel="bookmark" class="title">Url以&period;&lpar;点&rpar;结尾，在使用httpwebrequest读取的时候&comma;微软会有一个bug&hellip;&hellip;</a>
					<div>
						解决方法在此,不重复做赘述,传送门:http://stackoverflow.com/questions/856885/httpwebrequest-to-url-with-dot-at-the-en ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OmxbXM.html" rel="bookmark" class="title">利用html属性target模拟异步提交</a>
					<div>
						http://www.w3school.com.cn/tags/att_a_target.asp w3c中有提到,当target的参数值为framename的时候会提交到指定的ifram中处理. 比如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Omjl9M.html" rel="bookmark" class="title">学习java随笔第八篇：封装、继承、多态</a>
					<div>
						java和c#一样都是面向对象的语言. 面向对象的语言有三大特征:封装.继承.多态 封装 封装:隐藏对象的属性和实现细节,仅对外公开接口,控制在程序中属性的读和修改的访问级别. class Perso ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KaJwY4.html" rel="bookmark" class="title">tensorflow</a>
					<div>
						1.downloading and installing on ubuntu linux First, You shoud confirm that python is installed, and  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xQ1xr3.html" rel="bookmark" class="title">面向对象设计原则九：组合&sol;聚合复用原则</a>
					<div>
						组合/聚合复用原则(LSP) 定义:优先使用组合,使系统更灵活,其次才考虑继承,达到复用的目的.重用的方式: 继承.组合.聚合解释说明: 继承:在我们想复用代码时,我们一般会优先想到继承,但是具有继承 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0R8Kb74.html" rel="bookmark" class="title">Java IO5：序列化与反序列化</a>
					<div>
						一.序列化和反序列化的概念 把对象转换为字节序列的过程称为对象的序列化. 把字节序列恢复为对象的过程称为对象的反序列化. 对象的序列化主要有两种用途: 1) 把对象的字节序列永久地保存到硬盘上,通常存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4186AX3.html" rel="bookmark" class="title">SAE搭建WordPress教程 免费建WordPress博客站</a>
					<div>
						首先有新浪微博: SAE搭建WordPress教程 免费建WordPress博客站,布布扣,bubuko.com					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RYzDyM.html" rel="bookmark" class="title">Laravel的console使用方法</a>
					<div>
						适用场景:分析数据(日志) php artisan make:console 你的命令类名 示例: php artisan make:console Check 在\app\Console\Comma ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBRzYqM.html" rel="bookmark" class="title">使用SourceTree将bitbucket的远程仓库回滚到某一次提交－b</a>
					<div>
						目的: 使用SourceTree将bitbucket的远程仓库回滚到某一次提交. 原理: 在本地需要回滚的commit上创建一个分支,将该分支合并到远程仓库. 准备: 远程仓库有一个master主分支 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rk8y14.html" rel="bookmark" class="title">LeetCode 342&period; Power of Four （4的次方）</a>
					<div>
						Given an integer (signed 32 bits), write a function to check whether it is a power of 4. Example:Giv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dNp8r4.html" rel="bookmark" class="title">SQL 2014新特性- Delayed durability</a>
					<div>
						原文:SQL 2014新特性- Delayed durability ACID 是数据库的基本属性.其中的D是指&quot;持久性&quot;:只要事务已经提交,对应的数据修改就会被保存下来,即使出现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVzrGyM.html" rel="bookmark" class="title">jQuery MiniUI开发系列之：创建组件对象</a>
					<div>
						原文:http://miniui.com/bbs/forum.php?mod=viewthread&amp;tid=20&amp;extra=page%3D1 jQuery MiniUI可以使用Jav ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mo55WB3.html" rel="bookmark" class="title">C&num;中委托，匿名函数，lamda表达式复习</a>
					<div>
						一.委托 1.就给类比较,类用class声明,委托用delegate声明. 2.委托要指向一个真正的方法. 3.委托的签名,要和指向的方法一样. //1.声明一个委托 public delegate  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0je8jDM.html" rel="bookmark" class="title">【原】Java学习笔记008 - 方法（函数）</a>
					<div>
						1 package cn.temptation; 2 3 public class Sample01 { 4 public static void main(String[] args) { 5 // ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35rPxn4.html" rel="bookmark" class="title">线性时间排序</a>
					<div>
						1.计数排序 基本思想:对于每一个输入元素x,确定小于(或等于)x的元素个数,就可以确定x的存放位置. 特点:稳定排序 #include&lt;iostream&gt; #include&lt;vec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J9YdQ3.html" rel="bookmark" class="title">在SQL中使用自定义函数</a>
					<div>
						  由于数据库的一个表字段中多包含html标签,现在需要修改数据库的字段把html标签都替换掉.当然我可以通过写一个程序去修改,那毕竟有点麻烦.直接在查询分析器中执行,但是MS SQL Server并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ezgpv3.html" rel="bookmark" class="title">大话设计模式C&plus;&plus;实现-第23章-命令模式</a>
					<div>
						一.UML图 二.概念 命令模式(Command):将一个请求封装为一个对象,从而使你可用不同的请求对客户进行参数化,对请求进行排队或记录请求日志,以及支持可撤销的操作. 三.说明 角色: (1)Co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wBOlj0.html" rel="bookmark" class="title">M&period;2接口介绍</a>
					<div>
						M.2原名为NGFF接口,它是为超极本(Ultrabook)量身定做的新一代接口标准,以取代原来基于mini PCIe改良而来的mSATA接口.无论是更小巧的规格尺寸还是更高的传输性能M.2都远胜于m ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.021 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
